import mpi.*;

public class PiExampleCCL {
  public PiExampleCCL() {} 

  public PiExampleCCL(String[] args) throws Exception {
    int intervals[] = new int[1];
    int rank, tasks, i = 0;  
    final double PI25DT = 3.141592653589793238462643; 
    double mypi[] = new double[1];
    double pi[] = new double[1];
    double h, sum, x;

    MPI.Init(args);
    rank = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();
    
    intervals[0] = Integer.parseInt(args[0]);

    h = 1.0 / (double) intervals[0];
    sum = 0.0;
    for (i = rank + 1; i <= intervals[0]; i += tasks) {
      x = h * ((double)i - 0.5);
      sum += 4.0 / (1.0 + x*x);
    }
    mypi[0] = h * sum;

    MPI.COMM_WORLD.reduce(mypi, pi, 1, MPI.DOUBLE, MPI.SUM, 0);

    if (rank == 0) {
      System.out.println();
      System.out.printf("pi is approximately %.16f, Error is %.16f\n", pi[0], 
              Math.abs(pi[0] - PI25DT));
    }
    MPI.Finalize();
  } 

  public static void main (String[] args) { 
    try {
      PiExampleCCL c = new PiExampleCCL(args);
    } catch (Exception e) {
    }
  }
}
