/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/*
 The MIT License

 Copyright (c) 2013 - 2014
 1. SEECS, National University of Sciences and Technology, Pakistan (2013 - 2014)
 2. Bibrak Qamar  (2013 - 2014)

 Permission is hereby granted, free of charge, to any person obtaining
 a copy of this software and associated documentation files (the
 "Software"), to deal in the Software without restriction, including
 without limitation the rights to use, copy, modify, merge, publish,
 distribute, sublicense, and/or sell copies of the Software, and to
 permit persons to whom the Software is furnished to do so, subject to
 the following conditions:

 The above copyright notice and this permission notice shall be included
 in all copies or substantial portions of the Software.

 THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
 MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
 NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
 DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
 OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
 THE USE OR OTHER DEALINGS IN THE SOFTWARE.
 */

/*
 * File         : mpjdev_natmpjdev_shared.c
 * Author       : Bibrak Qamar
 * Created      : Tue Sept  17 11:15:11 PKT 2013
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 2014/03/11 11:30:00 $
 *
 */

#ifndef _MPI_COMMONS_
#define _MPI_COMMONS_
#ifdef __cplusplus
extern "C" {
#endif

extern jclass CL_mpi_Status;
extern jfieldID FID_mpi_Status_source;
extern jfieldID FID_mpi_Status_tag;
extern jfieldID FID_mpi_Status_count;
extern jfieldID FID_mpi_Status_index;
extern jfieldID FID_mpi_Status_numEls;
extern jfieldID FID_mpi_Status_handle;
extern jfieldID FID_mpi_Status_isBufferComms;
extern jmethodID MID_mpi_Status_constructor;

extern jfieldID FID_mpi_Comm_CommhandleID;

extern jclass CL_mpjbuf_Buffer;
extern jfieldID FID_mpjbuf_Buffer_staticBuffer;
extern jfieldID FID_mpjbuf_NIOBuffer_buffer;
extern jfieldID FID_mpjbuf_Buffer_size;

extern jclass CL_mpi_Request;
extern jclass CL_mpi_NativeRequest;
extern jfieldID FID_mpi_NativeRequest_requestHandle;
extern jmethodID MID_mpi_Request_complete;
extern jfieldID FID_mpi_Request_handle;
extern jfieldID FID_mpi_Request_isBufferComms;

#ifdef __cplusplus
}
#endif
#endif
