/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/*
The MIT License

Copyright (c) 2013 - 2014
  1. SEECS, National University of Sciences and Technology, Pakistan (2013 - 2014)
  2. Bibrak Qamar  (2013 - 2014)

Permission is hereby granted, free of charge, to any person obtaining
a copy of this software and associated documentation files (the
"Software"), to deal in the Software without restriction, including
without limitation the rights to use, copy, modify, merge, publish,
distribute, sublicense, and/or sell copies of the Software, and to
permit persons to whom the Software is furnished to do so, subject to
the following conditions:

The above copyright notice and this permission notice shall be included
in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF
MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN
NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM,
DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR
OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR
THE USE OR OTHER DEALINGS IN THE SOFTWARE.
*/

/*
 * File         : Constants.java
 * Author       : Bibrak Qamar
 * Created      : Tue Sept  17 11:15:11 PKT 2013
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 2014/03/11 11:30:00 $
 *
 */
package mpi;

/**
 * This class represents constants to be used for {@code Op}.
 */
public class Constants {

  // Operator constants (Macros) we may later put them in a
  // constants class at the mpi layer. These are currently
  // taken from MVAPICH2 mpi.h file.
  public static final int MAX_CODE = 0x58000001;
  public static final int MIN_CODE = 0x58000002;
  public static final int SUM_CODE = 0x58000003;
  public static final int PROD_CODE = 0x58000004;
  public static final int LAND_CODE = 0x58000005;
  public static final int BAND_CODE = 0x58000006;
  public static final int LOR_CODE = 0x58000007;
  public static final int BOR_CODE = 0x58000008;
  public static final int LXOR_CODE = 0x58000009;
  public static final int BXOR_CODE = 0x5800000a;
  public static final int MAXLOC_CODE = 0x5800000b;
  public static final int MINLOC_CODE = 0x5800000c;
}
