/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi;

/**
 * This class represents {@code MPI_Info}.
 */
public class Info {

  static final long NULL = nativeGetNull();
  public long handle = -1;

  public Info() {
    handle = nativeInfoCreate();
  }

  public Info(long handle) {
    this.handle = handle;
  }

  private static native long nativeGetNull();

  /**
   * set Info variables.
   *
   * @param key key
   * @param value value 
   *
   * <p>Java binding of the MPI operation {@code MPI_Info_set}.
   * 
   * @throws MPIException Points out that an MPI exception has occured.
   */
  public void set(String key, String value) {
    nativeSet(handle, key, value);
  }

  private native long nativeInfoCreate();

  private native void nativeSet(long handle, String key, String value);
}
