/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/*

/*
 * File         : Type.java
 * Author       : Jawad Manzoor
 * Created      : Tue Jul  21 2004
 * Revision     :
 * Updated      : $Date: 2009/07/21
 *
 */
package mpjbuf;

import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.io.ObjectStreamClass;
import java.net.URLClassLoader;

public class CustomObjectInputStream extends ObjectInputStream {

  URLClassLoader urlCl;

  protected CustomObjectInputStream() throws IOException {}

  public CustomObjectInputStream(InputStream in) throws IOException {
    super(in);
  }

  public void setClassLoader(URLClassLoader ucl) {
    urlCl = ucl;
  }

  @Override
  public Class resolveClass(ObjectStreamClass desc) throws IOException {

    String name = desc.getName();
    try {
      URLClassLoader u = (URLClassLoader) Thread.currentThread().getContextClassLoader();
      return Class.forName(name, false, u);
    } catch (ClassNotFoundException ex) {
      return null;
    }
  }
}
