## Running tests
MVAPICH2-J has a collection of tests that is used in testing its functionality.
To run those tests, the following commands are needed.

First, compile the tests.
```
$ ./compile.sh
```

Second, add a hosts file with the desired set of hostnames on which the
application will run on.

```
$ cat hosts
<hostname1>
<hostname2>
```

Finally, simple pick one of the set of scripts that runs a group of tests. For
this example, run the following script.

```
$ ./run_pt2pt.sh
```

Some of the expected output is shown below,

```
Running:   mpi.pt2pt.BreakANYSRC
 sending
 receiving
 received it ..
 called wait for send
test #1 passed
test #2 passed
 calling recv
 calling send
 sent
 received
test #3 passed
 BreakANYSRC TEST COMPLETED
 BreakANYSRC TEST COMPLETED 0
 BreakANYSRC TEST COMPLETED 1

Running:   mpi.pt2pt.BufferTest1

#################
 <<<<CONTENTS PASSED>>>>
################

#################
 <<<<STATUS PASSED>>>>
################
BufferTest1:Standard:Blocking send/recv test completed

Running:   mpi.pt2pt.BufferTest3
BufferTest3 (mpjbuf.Buffers only) TEST Completed
BufferTest3 (mpjbuf.Buffers only) TEST Completed

...
```
