/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.ccl_ObjSer;

/****************************************************************************
 *
 * Object version :
 * Sang Lim(slim@npac.syr.edu)
 * Northeast Parallel Architectures Center at Syracuse University
 * 11/28/98
 ****************************************************************************/

import mpi.*;

public class alltoallO {
  public alltoallO() {}

  public alltoallO(String[] args) throws Exception {

    final int MAXLEN = 10;

    int i, j, k, l;
    int myself, tasks;

    MPI.Init(args);
    myself = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();

    int out[][] = new int[MAXLEN * tasks][MAXLEN];
    int in[][] = new int[MAXLEN * tasks][];

    for (k = 0; k < MAXLEN; k++) for (i = 0; i < MAXLEN * tasks; i++) out[i][k] = k;

    MPI.COMM_WORLD.allToAll(out, MAXLEN, MPI.OBJECT, in, MAXLEN, MPI.OBJECT);

    for (k = 0; k < MAXLEN * tasks; k++)
      for (l = 0; l < MAXLEN; l++) {
        if (in[k][l] != l) {
          System.out.println(
              "bad answer in[" + k + "][" + l + "] = " + in[k][l] + " should be " + l);
          break;
        }
      }

    MPI.COMM_WORLD.barrier();
    if (myself == 0) System.out.println("AllToAllO TEST COMPLETE");
    MPI.Finalize();
  }

  public static void main(String[] args) throws Exception {
    try {
      alltoallO c = new alltoallO(args);
    } catch (Exception e) {
    }
  }
}
