/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.ccl_ObjSer;

/***************************************************************************
 *
 * Object version :
 * Sang Lim(slim@npac.syr.edu)
 * Northeast Parallel Architectures Center at Syracuse University
 * 11/15/98
 ****************************************************************************/

import mpi.*;

public class gatherO {
  public gatherO() {}

  public gatherO(String[] args) throws Exception {

    int root = 0, i, j, k, l;
    int myself, tasks;

    MPI.Init(args);
    myself = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();

    int out[][] = new int[6][3];
    int in[][] = new int[6 * tasks][];

    for (j = 0; j < tasks; j++) {
      if (j == myself) for (l = 0; l < 6; l++) for (i = 0; i < 3; i++) out[l][i] = l + j * 6;
    }

    MPI.COMM_WORLD.gather(out, 6, MPI.OBJECT, in, 6, MPI.OBJECT, root);

    if (root == myself) {
      for (l = 0; l < 6 * tasks; l++)
        for (i = 0; i < 3; i++)
          if (in[l][i] != l)
            System.out.println(
                "Recived data : "
                    + in[l][i]
                    + "at recive buffer["
                    + l
                    + "]["
                    + i
                    + "] should be : "
                    + l);
    }

    MPI.COMM_WORLD.barrier();
    if (myself == root) System.out.println("GatherO TEST COMPLETE");
    MPI.Finalize();
  }

  public static void main(String[] args) throws Exception {
    try {
      gatherO c = new gatherO(args);
    } catch (Exception e) {
    }
  }
}
