/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.comm;

import mpi.*;

import java.util.Arrays;

public class comm_test {

  public comm_test() {}

  public comm_test(String[] args) throws Exception {

    MPI.Init(args);
    Group grp1 = MPI.COMM_WORLD.getGroup();
    Comm myComm;
    int[] incl1 = {0, 2, 4, 6};
    int rank = MPI.COMM_WORLD.getRank();
    int size = MPI.COMM_WORLD.getSize();

    if (size < 8) {
      if (rank == 0) System.out.println("comm->comm_test: RUNS WITH 8 processes atleast");

      MPI.COMM_WORLD.barrier();
      MPI.Finalize();
      return;
    }

    Group grp2 = grp1.incl(incl1);

    myComm = MPI.COMM_WORLD.create(grp2);

    MPI.COMM_WORLD.barrier();

    if (rank == 0) System.out.println("comm_test TEST COMPLETE");

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    try {
      comm_test a = new comm_test(args);
    } catch (Exception e) {
    }
  }
}
