/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.comm;

import mpi.*;

public class split2 {
  public split2() {}

  public split2(String[] args) throws Exception {

    MPI.Init(args);
    int size = MPI.COMM_WORLD.getSize();
    int rank = MPI.COMM_WORLD.getRank();

    if (size != 8) {
      if (rank == 0) System.out.println("comm->split2: MUST RUN WITH 8 processes");
      MPI.COMM_WORLD.barrier();
      MPI.Finalize();
      return;
    }

    int color = 2 * rank / size;
    int key = size - rank - 1;
    Intracomm newcomm = MPI.COMM_WORLD.split(color, key);
    int nrank = newcomm.getRank();

    MPI.COMM_WORLD.barrier();
    if (rank == 0) System.out.println("split2 TEST COMPLETE");
    MPI.Finalize();
  }

  public static void main(String[] args) throws Exception {
    try {
      split2 a = new split2(args);
    } catch (Exception e) {
    }
  }
}
