/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.dtyp;

import mpi.*;

import java.util.Arrays;

/**
 * This example application, is to check and demonstrate the functonality of contiguous datatypes.
 * I'm writing an MPJ program by coverting a C program by Forest Hoffman at following URL
 * http://www.linux-mag.com/2003-04/extreme_01.html
 */
public class DtypTest {

  public DtypTest() {}

  public DtypTest(String[] args) throws Exception {
    MPI.Init(args);
    int i, j, k, rank, size, dest, src, tag;
    rank = MPI.COMM_WORLD.getRank();
    size = MPI.COMM_WORLD.getSize();
    src = 0;
    dest = 1;
    tag = 10;

    if (rank == 1) {

    } else if (rank == 0) {
      System.out.println(" Checking out, extent, lb, ub of basic datatypes ");
      System.out.println(" Byte***** ");
      System.out.println(" ext " + MPI.BYTE.extent());
      System.out.println(" lb  " + MPI.BYTE.lb());
      System.out.println(" ub  " + MPI.BYTE.ub());
      System.out.println(" Boolean***** ");
      System.out.println(" ext " + MPI.BOOLEAN.extent());
      System.out.println(" lb  " + MPI.BOOLEAN.lb());
      System.out.println(" ub  " + MPI.BOOLEAN.ub());
      System.out.println(" char***** ");
      System.out.println(" ext " + MPI.CHAR.extent());
      System.out.println(" lb  " + MPI.CHAR.lb());
      System.out.println(" ub  " + MPI.CHAR.ub());
      System.out.println(" short***** ");
      System.out.println(" ext " + MPI.SHORT.extent());
      System.out.println(" lb  " + MPI.SHORT.lb());
      System.out.println(" ub  " + MPI.SHORT.ub());
      System.out.println(" int ***** ");
      System.out.println(" ext " + MPI.INT.extent());
      System.out.println(" lb  " + MPI.INT.lb());
      System.out.println(" ub  " + MPI.INT.ub());
      System.out.println(" float***** ");
      System.out.println(" ext " + MPI.FLOAT.extent());
      System.out.println(" lb  " + MPI.FLOAT.lb());
      System.out.println(" ub  " + MPI.FLOAT.ub());
      System.out.println(" long***** ");
      System.out.println(" ext " + MPI.LONG.extent());
      System.out.println(" lb  " + MPI.LONG.lb());
      System.out.println(" ub  " + MPI.LONG.ub());
      System.out.println(" double***** ");
      System.out.println(" ext " + MPI.DOUBLE.extent());
      System.out.println(" lb  " + MPI.DOUBLE.lb());
      System.out.println(" ub  " + MPI.DOUBLE.ub());
      System.out.println(" Upper Bound (UB)***** ");
      System.out.println(" ext " + MPI.UB.extent());
      System.out.println(" lb  " + MPI.UB.lb());
      System.out.println(" ub  " + MPI.UB.ub());
      System.out.println(" Lower Bound (LB)***** ");
      System.out.println(" ext " + MPI.LB.extent());
      System.out.println(" lb  " + MPI.LB.lb());
      System.out.println(" ub  " + MPI.LB.ub());
    }

    try {
      Thread.currentThread().sleep(1000);
    } catch (Exception e) {
    }
    MPI.COMM_WORLD.barrier();
    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    try {
      DtypTest c = new DtypTest(args);
    } catch (Exception e) {
    }
  }
}
