/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.dtyp;

/*
 * File         : type_size.java
 * Author       : Sung-Hoon Ko
 * Created      : Fri Jul 10 15:07:58 1998
 * Revision     : $Revision: 1.1 $
 * Updated      : $Date: 2005/04/15 11:36:35 $
 * Copyright: Northeast Parallel Architectures Center
 *            at Syracuse University 1998
 */

import mpi.*;

public class type_size {
  public type_size() {}

  public type_size(String[] args) throws Exception {
    int my_rank;

    MPI.Init(args);
    my_rank = MPI.COMM_WORLD.getRank();
    if (my_rank == 0) {
      System.out.println();
      System.out.println("MPI.BYTE.size()    = " + MPI.BYTE.size());
      System.out.println("MPI.CHAR.size()    = " + MPI.CHAR.size());
      System.out.println("MPI.SHORT.size()   = " + MPI.SHORT.size());
      System.out.println("MPI.BOOLEAN.size() = " + MPI.BOOLEAN.size());
      System.out.println("MPI.INT.size()     = " + MPI.INT.size());
      System.out.println("MPI.LONG.size()    = " + MPI.LONG.size());
      System.out.println("MPI.FLOAT.size()   = " + MPI.FLOAT.size());
      System.out.println("MPI.DOUBLE.size()  = " + MPI.DOUBLE.size());
      System.out.println();
      System.out.println("type_size TEST COMPLETED");
    }

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    try {
      type_size c = new type_size(args);
    } catch (Exception e) {
    }
  }
}
