/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.env;

import mpi.*;

import java.io.*;

public class InputTester {

  public InputTester(String argv[]) throws Exception {
    MPI.Init(argv);
    int id = MPI.COMM_WORLD.getRank();
    BufferedReader in = new BufferedReader(new InputStreamReader(System.in));
    String input;

    System.out.println("My id is: " + id);

    // get Input on process 0
    if (id == 0) {
      System.out.println("Enter a number in [ 0, 1000 ] : ");
      try {
        input = in.readLine();
        System.out.println("Got input. Value is: " + input);
      } catch (IOException e) {
        System.err.println("Exception while reading User Input");
        e.printStackTrace();
      }
    }

    MPI.COMM_WORLD.barrier();
    MPI.Finalize();
  }

  public static void main(String argv[]) {}
}
