/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.group;

import mpjbuf.*;
import mpi.*;

import java.util.Arrays;

public class Group_diff {

  public Group_diff() {}

  public Group_diff(String[] args) throws Exception {
    MPI.Init(args);
    Group grp = MPI.COMM_WORLD.getGroup();
    int me = grp.getRank();
    int tasks = grp.getSize();

    if (tasks < 8) {
      if (me == 0) System.out.println("group->Group_diff: MUST RUN with 8 tasks");
      MPI.COMM_WORLD.barrier();
      MPI.Finalize();
      return;
    }

    int[] incl1 = {4, 0, 5, 6};
    int[] incl2 = {6, 7, 4};
    Group grp1 = grp.incl(incl1);
    Group grp2 = grp.incl(incl2);
    Group grp3 = null;
    grp3 = Group.difference(grp1, grp2);

    if (grp3.getSize() != 2) {
      System.out.println(" Error(1): ....");
    }

    MPI.COMM_WORLD.barrier();

    if (me == 0) System.out.println("Group_diff TEST COMPLETED");

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    try {
      Group_diff a = new Group_diff(args);
    } catch (Exception e) {
    }
  }
}
