/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.group;

import mpjbuf.*;
import mpi.*;

import java.util.Arrays;

public class Group_excl {

  public Group_excl() {}

  public Group_excl(String[] args) throws Exception {

    MPI.Init(args);
    Group grp = MPI.COMM_WORLD.getGroup();
    int me = grp.getRank();
    int tasks = grp.getSize();

    if (tasks < 8) {
      if (me == 0) System.out.println("group->Group_excl: MUST RUN with 8 tasks");
      MPI.COMM_WORLD.barrier();
      MPI.Finalize();
      return;
    }

    int[] excl = {5, 6, 0, 2, 3};
    Group ngrp = grp.excl(excl);

    if (ngrp.getSize() != 3) {
      System.out.println(" Error(1): ...");
    }

    MPI.COMM_WORLD.barrier();

    if (me == 0) System.out.println("Group_excl TEST COMPLETED");

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    try {
      Group_excl a = new Group_excl(args);
    } catch (Exception e) {
    }
  }
}
