/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.perf;

import mpi.*;

class barrier_bench {
  public static void main(String[] args) throws MPIException {

    final int MAXLEN = 1024;
    int root, i, j = MAXLEN, k;
    int REPEAT = 1000;
    int WARM_UP = 10;
    int myself, tasks;
    double time;

    MPI.Init(args);
    myself = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();
    root = 0;
    long startTime = 0l, endTime = 0l;

    for (j = 0; j < WARM_UP; j++) {
      MPI.COMM_WORLD.barrier();
    }

    for (j = 0; j < REPEAT; j++) {
      MPI.COMM_WORLD.barrier();
    }

    MPI.COMM_WORLD.barrier();
    MPI.Finalize();
  }
}
