/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.perf;

import mpi.*;

class bcast_bench {
  public static void main(String[] args) throws MPIException {

    final int MAXLEN = 1024;
    int root, i, j = MAXLEN, k;
    byte out[] = new byte[MAXLEN];
    int REPEAT = 1000;
    int WARM_UP = 10;
    int myself, tasks;
    // double time;

    for (i = 0; i < j; i++) {
      out[i] = 's'; // (byte)i+j;
    }

    MPI.Init(args);
    myself = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();
    root = 0;
    long startTime, endTime;

    for (j = 0; j < WARM_UP; j++) {
      MPI.COMM_WORLD.bcast(out, 1024, MPI.BYTE, root);
    }

    // startTime = MPI.wtime();

    for (j = 0; j < REPEAT; j++) {
      MPI.COMM_WORLD.bcast(out, 1024, MPI.BYTE, root);
    }

    // endTime = MPI.wtime();
    if (myself == tasks - 1) {
      //    System.out.println(tasks+"     "+
      //		    ((endTime - startTime)/(1000*REPEAT)) );
    }
    MPI.COMM_WORLD.barrier();
    MPI.Finalize();
  }
}
