/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.pt2pt;

import mpi.*;

import java.util.Arrays;

public class SimpleNB {
  public SimpleNB(String args[]) throws Exception {
    Request sreq = null;
    mpi.Status status = null;
    MPI.Init(args);

    int intArray[] = new int[100];
    int intReadArray[] = new int[100];

    for (int i = 0; i < intArray.length; i++) {
      intArray[i] = i + 1;
      intReadArray[i] = 3;
    }

    if (MPI.COMM_WORLD.getRank() == 0) {

      sreq = MPI.COMM_WORLD.isSend(intArray, 100, MPI.INT, 1, 999);
      status = sreq.waitStatus();

    } else if (MPI.COMM_WORLD.getRank() == 1) {
      sreq = MPI.COMM_WORLD.iRecv(intReadArray, 100, MPI.INT, 0, 999);
      status = sreq.waitStatus();

      if (Arrays.equals(intArray, intReadArray)) {
        System.out.println("\n#################" + "\n <<<<PASSED>>>> " + "\n################");
      } else {
        System.out.println("\n#################" + "\n <<<<FAILED>>>> " + "\n################");
      }
    }

    status.free();

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    SimpleNB test = new SimpleNB(args);
  }
}
