/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.pt2pt;

import mpi.*;

import java.util.Arrays;

public class Ssend_test1 {
  public Ssend_test1() {}

  public Ssend_test1(String args[]) throws Exception {

    MPI.Init(args);

    int intArray[] = new int[100];
    float floatArray[] = new float[100];
    double doubleArray[] = new double[100];
    long longArray[] = new long[100];
    boolean booleanArray[] = new boolean[100];
    short shortArray[] = new short[100];
    char charArray[] = new char[100];
    byte byteArray[] = new byte[100];
    int intReadArray[] = new int[100];
    float floatReadArray[] = new float[100];
    double doubleReadArray[] = new double[100];
    long longReadArray[] = new long[100];
    boolean booleanReadArray[] = new boolean[100];
    short shortReadArray[] = new short[100];
    char charReadArray[] = new char[100];
    byte byteReadArray[] = new byte[100];

    for (int i = 0; i < intArray.length; i++) {
      intArray[i] = i + 1;
      floatArray[i] = i + 11;
      doubleArray[i] = i + 11.11;
      longArray[i] = i + 11;
      booleanArray[i] = true;
      shortArray[i] = 1;
      charArray[i] = 's';
      byteArray[i] = 's';
      intReadArray[i] = 3;
      floatReadArray[i] = i + 19;
      doubleReadArray[i] = i + 99.11;
      longReadArray[i] = i + 9;
      shortReadArray[i] = 2;
      booleanReadArray[i] = false;
      charReadArray[i] = 'x';
      byteReadArray[i] = 'x';
    }

    if (MPI.COMM_WORLD.getRank() == 0) {
      MPI.COMM_WORLD.sSend(intArray, 100, MPI.INT, 1, 999);
      MPI.COMM_WORLD.sSend(byteArray, 100, MPI.BYTE, 1, 998);
      MPI.COMM_WORLD.sSend(charArray, 100, MPI.CHAR, 1, 997);
      MPI.COMM_WORLD.sSend(doubleArray, 100, MPI.DOUBLE, 1, 996);
      MPI.COMM_WORLD.sSend(longArray, 100, MPI.LONG, 1, 995);
      MPI.COMM_WORLD.sSend(booleanArray, 100, MPI.BOOLEAN, 1, 994);
      MPI.COMM_WORLD.sSend(shortArray, 100, MPI.SHORT, 1, 993);
      MPI.COMM_WORLD.sSend(floatArray, 100, MPI.FLOAT, 1, 992);
    } else if (MPI.COMM_WORLD.getRank() == 1) {
      MPI.COMM_WORLD.recv(intReadArray, 100, MPI.INT, 0, 999);
      MPI.COMM_WORLD.recv(byteReadArray, 100, MPI.BYTE, 0, 998);
      MPI.COMM_WORLD.recv(charReadArray, 100, MPI.CHAR, 0, 997);
      MPI.COMM_WORLD.recv(doubleReadArray, 100, MPI.DOUBLE, 0, 996);
      MPI.COMM_WORLD.recv(longReadArray, 100, MPI.LONG, 0, 995);
      MPI.COMM_WORLD.recv(booleanReadArray, 100, MPI.BOOLEAN, 0, 994);
      MPI.COMM_WORLD.recv(shortReadArray, 100, MPI.SHORT, 0, 993);
      MPI.COMM_WORLD.recv(floatReadArray, 100, MPI.FLOAT, 0, 992);

      if (Arrays.equals(intArray, intReadArray)
          && Arrays.equals(floatArray, floatReadArray)
          && Arrays.equals(doubleArray, doubleReadArray)
          && Arrays.equals(longArray, longReadArray)
          && Arrays.equals(shortArray, shortReadArray)
          && Arrays.equals(charArray, charReadArray)
          && Arrays.equals(byteArray, byteReadArray)
          && Arrays.equals(booleanArray, booleanReadArray)) {

        System.out.println("\n#################" + "\n <<<<PASSED>>>> " + "\n################");

      } else {
        System.out.println("\n#################" + "\n <<<<FAILED>>>> " + "\n################");
      }
    }

    MPI.COMM_WORLD.barrier();

    if (MPI.COMM_WORLD.getRank() == 0) {
      System.out.println("Ssend_test1 TEST Completed");
    }

    MPI.Finalize();
  }

  public static void main(String args[]) throws Exception {
    Ssend_test1 test = new Ssend_test1(args);
  }
}
