/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.pt2pt;

import mpi.*;

public class cancel1 {
  public cancel1() {}

  public cancel1(String[] args) throws Exception {
    int me, cnt = 1, src = -1, tag;
    int data[] = new int[1];
    boolean flag;
    Intracomm comm;
    Status status = null;
    Request request = null;

    MPI.Init(args);
    comm = MPI.COMM_WORLD;
    me = comm.getRank();

    if (me == 0) {
      data[0] = 7;
      request = comm.iSend(data, 1, MPI.INT, 1, 1);
      request.cancel();
      status = request.waitStatus();

      if (status.isCancelled()) {
        System.out.println("Error(2): Should not be cancelled");
      }

    } else if (me == 1) {
      request = comm.iRecv(data, 1, MPI.INT, 0, 1);
      System.out.println("rank 1 calling Wait");
      status = request.waitStatus();
      System.out.println("rank 1 called Wait");

      if (data[0] != 7) {
        System.out.println("Error(1): Should be 7");
      }
    }

    status.free();

    comm.barrier();
    System.out.println("Cancel1 TEST COMPLETE\n");
    MPI.Finalize();
    System.out.println("Even ..finalized");
  }

  public static void main(String[] args) throws Exception {}
}
