/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.pt2pt;

import mpi.*;

public class dacian_test {

  public dacian_test(String[] args) {

    MPI.Init(args);
    int rank = MPI.COMM_WORLD.getRank();

    if (rank == 0) {
      String[] msg = new String[10];
      msg[0] = new String("Hello");
      MPI.COMM_WORLD.send(msg, 1, MPI.OBJECT, 1, 13);
    } else {
      String[] message = new String[10];
      MPI.COMM_WORLD.recv(message, 1, MPI.OBJECT, 0, 13);
      System.out.println(message[0]);
    }

    MPI.Finalize();
  }
}
