/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.pt2pt;

import mpi.*;

class syncbug {
  public static void main(String[] args) throws Exception {

    int me, tasks, i;
    int SIZE = 4;
    int[] s = new int[SIZE];
    int[] r = new int[SIZE];
    int tag = 87;
    MPI.Init(args);
    me = MPI.COMM_WORLD.getRank();
    tasks = MPI.COMM_WORLD.getSize();
    Request req[] = new Request[SIZE];
    Status st[] = new Status[SIZE];

    if (me == 0) {

      for (i = 0; i < SIZE; i++) {
        req[i] = MPI.COMM_WORLD.isSend(s, SIZE, MPI.INT, 1, tag + i);
      }

      for (i = 0; i < SIZE; i++) {
        MPI.COMM_WORLD.recv(r, SIZE, MPI.INT, 1, tag + i);
      }

      for (i = 0; i < SIZE; i++) {
        st[i] = req[i].waitStatus();
        st[i].free();
      }

    } else {

      for (i = 0; i < SIZE; i++) {
        req[i] = MPI.COMM_WORLD.isSend(s, SIZE, MPI.INT, 0, tag + i);
      }

      for (i = 0; i < SIZE; i++) {
        MPI.COMM_WORLD.recv(s, SIZE, MPI.INT, 0, tag + i);
      }

      for (i = 0; i < SIZE; i++) {
        st[i] = req[i].waitStatus();
        st[i].free();
      }
    }

    if (me == 0) {
      System.out.println("SyncBug successfully completed");
    }
    MPI.COMM_WORLD.barrier();
    MPI.Finalize();
  }
}
