/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

package mpi.signals;

import mpi.*;

import java.io.*;

public class TestTask implements Task, Serializable {

  String pool_proc;
  String ack = null;

  public TestTask() {
    this.pool_proc = "un-initialized";
  }

  public TestTask(String s) {
    this.pool_proc = s;
  }

  public Result runTask() {
    System.out.println("***********************************");
    System.out.println("I come from " + this.pool_proc);

    int my_pe = 0;

    try {
      System.out.println("I am right now on " + MPI.getProcessorName());
      my_pe = MPI.COMM_WORLD.getRank();
    } catch (Exception e) {
      System.err.println("Error in TestTask.runTask() " + e);
    }

    System.out.println("***********************************");
    // returning the name of the processor this task ran on..
    return new TestResult(my_pe);
  }

  public void setAck(String s) {
    this.ack = "recieved ack by " + s;
  }

  public void setResult(Result output) {}

  public String toString() {
    return "Task sent from " + pool_proc + " ack : " + ack;
  }
}
