/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

import mpi.Info;
import mpi.Intercomm;
import mpi.MPI;

public class Manager {
  public static void main(String[] args) throws Exception {
    int world_size = 0;
    int universe_size = 0;
    int flag = 0;

    Intercomm everyone;
    Info info;

    MPI.Init(args);
    world_size = MPI.COMM_WORLD.getSize();
    System.out.println("world_size " + world_size);

    if (world_size != 1) {
      System.out.println("Top heavy with management");
      System.exit(1);
    }

    info = new Info();

    info.set("hosts", "gpu18,gpu19");

    String[] spawn_argv = {
      "-cp",
      "/home/alattar.2/mvapich2-j/lib/mvapich2-j.jar:.",
      "-Djava.library.path=/home/alattar.2/mvapich2-j/lib",
      "Worker"
    };

    everyone = MPI.COMM_SELF.spawn("java", spawn_argv, 2, info, 0, null);

    MPI.Finalize();
  }
}
