/* Copyright (c) 2001-2022, The Ohio State University. All rights
 * reserved.
 *
 * This file is part of the MVAPICH2-J software package developed by the
 * team members of The Ohio State University's Network-Based Computing
 * Laboratory (NBCL), headed by Professor Dhabaleswar K. (DK) Panda.
 *
 * For detailed copyright and licensing information, please refer to the
 * copyright file COPYRIGHT in the top level MVAPICH2-J directory.
 */

import mpi.Intercomm;
import mpi.MPI;

public class Worker {
  public static void main(String[] args) throws Exception {
    int size;
    Intercomm parent;

    MPI.Init(args);
    parent = Intercomm.getParent();
    if (parent == null) {
      System.out.println("No parent!");
      System.exit(1);
    }

    size = parent.getRemoteSize();
    System.out.println("parent size " + size);
    String name = MPI.getProcessorName();
    System.out.println("hostname " + name);
    if (size != 1) {
      System.out.println("Something's wrong with the parent");
      System.exit(1);
    }

    MPI.Finalize();
  }
}
